/*
Selects the given Generation Number's statistics with Best Fitness
value
*/

#include<stdio.h>
#include<stdlib.h>

struct StatEle
{  double sigma;
   double averageBest;
   int numOfSamples;
};

void init_statarray(arr, max)
struct StatEle *arr;
int max;
{  int i;
   printf("\n I am in init_statarray \n");
   for(i=0;i<max;i++)
   {  arr[i].sigma = 0.0;
      arr[i].averageBest = 0.0;
      arr[i].numOfSamples = 0;
   }/* end of for */
}/* end of init_statarray() */

void swap(arr,i,j)
struct StatEle *arr;
int i,j;
{  double dummy1,dummy2;
   int    dummy3;

   /* */
   dummy1 = arr[i].sigma;
   dummy2 = arr[i].averageBest;
   dummy3 = arr[i].numOfSamples;

   /* */
   arr[i].sigma = arr[j].sigma;
   arr[i].averageBest = arr[j].averageBest;
   arr[i].numOfSamples = arr[j].numOfSamples;

   /* */
   arr[j].sigma = dummy1;
   arr[j].averageBest = dummy2;
   arr[j].numOfSamples = dummy3;
   
}/* end of swap() */

void sort(arr, max)
struct StatEle *arr;
int max;
{  int i,j;
   
   for(i=0;i<max-1;i++)
   for(j=i+1;j<max;j++)
     if(arr[i].sigma>arr[j].sigma) swap(arr,i,j);
   
}/* end of sort() */

void average(arr, max)
struct StatEle *arr;
int max;
{  int j;
   
   for(j=0;j<max;j++)
     arr[j].averageBest=arr[j].averageBest/(double)arr[j].numOfSamples;
   
}/* end of average() */


void write_array(arr, max, fp)
struct StatEle *arr;
int max;
FILE *fp;
{  int j;
   
   for(j=0;j<max;j++)
     fprintf(fp,"%12.8f %12.8f \n",arr[j].sigma,arr[j].averageBest);

}/* end of write() */


int Exist(arr, max, sigma)
struct StatEle *arr;
int max;
double sigma;
{  int j;
   int ret=0;
   
   for(j=0;j<max&&!ret;j++)
     if(arr[j].sigma==sigma) ret=j+1;

   return ret;

}/* end of Exist() */

main(argc,argv)
int argc;
char *argv[];
{  FILE *fout, *fin;
   float col2, col3, col4;
   float col5, col6, col7;
   float col8, col9, col1;
   float cols[2][10];
   struct StatEle array[10];
   int k=0, i , j, even, first, second,third;
   char outFName[30]; 


   printf("\n I start running \n");

   init_statarray(array,10);

   printf("\n I initialize the array \n");

   if(argc>1)
   {  if((fin=fopen(argv[1],"r"))!=NULL)
      {  
	 if(argc==4) sprintf(outFName,"%s",argv[3]);
	 else sprintf(outFName,"%s","SigmaFit.out");
	 outFName[29]=NULL;
	 if((fout=fopen(outFName,"w"))!=NULL)
	 {  first = 250;
	    second = 2;
	    third  = 3;

	    if(argc>2)
	    {  sscanf(argv[2],"%d",&first);
	    }

            k=0;
            while(fscanf(fin,"%f %f %f %f %f %f %f %f %f \n",&cols[0][1],&cols[0][2],&cols[0][3],&cols[0][4],&cols[0][5],&cols[0][6],&cols[0][7],&cols[0][8],&cols[0][9])!=EOF)
	    { 
	      /* if this is generation that we are looking for */

	      if(cols[0][4]==first)
	      {  
		  if(!(j=Exist(array,k,cols[0][2])))
		  {  array[k].sigma = cols[0][2];
		     array[k].averageBest = cols[0][5];
		     array[k].numOfSamples = 1;
		     k++;
		  } 
		  else
		    {  j--; 
		       array[j].numOfSamples++;
		       array[j].averageBest = array[j].averageBest + cols[0][5];
		    }
	      }

	    }/* end of while */

	    sort(array,k);

	    /* apply averaging */

	    average(array,k);

	    write_array(array,k,fout);
            
	    fclose(fout);
	 }

         fclose(fin);
      }
      else printf("\n File %s does not exist!!\n",argv[1]);
   }
   else printf("\n usage: <prog-name> InFileName <OutFileName] \n");
}
